/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.tearabite;

import com.pi4j.Pi4J;
import com.pi4j.context.Context;
import com.pi4j.context.ContextBuilder;
import com.pi4j.util.Console;
import com.tearabite.bot.Arm;
import com.tearabite.hardware.Board;

import java.lang.reflect.InvocationTargetException;

public class Main {
    private static final Console console = new Console();

    public static void main(String[] args) {
        console.box("Hello Rasbian world !");
        try {
            new Main().run();
        } catch (InvocationTargetException e) {
            console.println("Error: " + e.getTargetException().getMessage());
        } catch (Exception e) {
            console.println("Error: " + e.getMessage());
            e.printStackTrace();
        }
    }

    private void run() throws Exception {
        ContextBuilder pi4jb = Pi4J.newContextBuilder();
        Context pi4j = pi4jb.autoDetect().build();

        Board board = new Board(pi4j);
        board.start();
        Arm arm = new Arm(board);
        board.beep(250);
        for(int i = 0; i < 5; i++) {
            arm.reset();
            Thread.sleep(2000);
            arm.extend();
            Thread.sleep(2000);
            arm.spin(-1);
            Thread.sleep(1000);
            arm.spin(1);
            Thread.sleep(1000);
        }
        arm.reset();
        Thread.sleep(3000);

        pi4j.shutdown();
    }
}
