package com.tearabite.base;

import com.pi4j.context.Context;
import com.pi4j.io.i2c.I2C;
import com.pi4j.io.i2c.I2CProvider;

public abstract class I2CDevice extends Component {
    protected static final int DEFAULT_BUS = 0x01;
    protected final I2C i2c;


    protected I2CDevice(Context pi4j, int device, String name){
        I2CProvider i2CProvider = pi4j.provider("pigpio-i2c");
        i2c = i2CProvider.create(I2C.newConfigBuilder(pi4j)
                .id("I2C-" + DEFAULT_BUS + "@" + device)
                .name(name+ "@" + device)
                .bus(DEFAULT_BUS)
                .device(device)
                .build());
        init(i2c);
        logDebug("I2C device %s initialized", name);
    }

    protected void init(I2C i2c) {};
}
