package com.tearabite.bot;

import com.tearabite.hardware.Board;
import com.tearabite.hardware.Servo;

public class Arm {
    private final Servo claw;
    private final Servo wrist;
    private final Servo elbow;
    private final Servo shoulder;
    private final Servo spin;

    public Arm(Board board) {
        this.claw = board.getServo(0);
        this.claw.scaleRange(0, 0.7);

        this.wrist = board.getServo(2);
        this.wrist.scaleRange(-0.8, 0.8);

        this.elbow = board.getServo(3);
        this.elbow.scaleRange(-0.6, 0.6);

        this.shoulder = board.getServo(4);
        this.shoulder.scaleRange(-0.2, 1);

        this.spin = board.getServo(5);
        double fudge = -0.01;
        double width = 0.4;
        this.spin.scaleRange(-width / 2 + fudge, width / 2 + fudge);
        this.reset();
    }

    public void reset() {
        this.claw.setPosition(-1);
        this.wrist.setPosition(-0.3);
        this.elbow.setPosition(1);
        this.shoulder.setPosition(-1);
        this.spin.setPosition(0);
    }

    public void extend() {
        this.claw.setPosition(0);
        this.wrist.setPosition(0);
        this.elbow.setPosition(0);
        this.shoulder.setPosition(1);
    }

    public void spin(double pos) {
        this.spin.setPosition(pos);
    }
}
