package com.tearabite.hardware;

import com.pi4j.context.Context;

public class Board extends BoardCore {

    public Board(Context pi4j) {
        super(pi4j);
    }

    public void setPwmServoAngle(int index, int angle) {
        if (index < 0 || index >= 6) {
            throw new IllegalArgumentException(String.format("Invalid servo num: %d", index));
        }

        this.servoAngles[index] = Math.max(Math.min(angle, 180), 0);
    }

    public void setMotorSpeed(int index, int speed) {
        if (index < 0 || index >= 4) {
            throw new IllegalArgumentException(String.format("Invalid motor num: %d", index));
        }

        this.motorSpeeds[index] = Math.max(Math.min(speed, 100), -100);
    }

    public void beep(int duration) {
        this.beepUntil = System.currentTimeMillis() + duration;
    }

    public DcMotor getMotor(int index) {
        return new DcMotor(this, index);
    }

    public Servo getServo(int index) {
        return new Servo(this, (byte) index);
    }
}

