package com.tearabite.hardware;

public class Servo {
    private final Board board;
    private final byte index;
    private double position;
    private double min;
    private double max;

    public Servo(Board board, byte index) {
        this.board = board;
        this.index = index;
    }

    public void setPosition(double position) {
        double remappedValue = ((position + 1) / 2) * (max - min) + min;
        this.position = remappedValue;
        double scaledValue = remappedValue * 180 + 90;
        this.board.setPwmServoAngle(this.index, (int)scaledValue);
    }

    public double getPosition() {
        return this.position;
    }

    public void scaleRange(double min, double max) {
        this.min = min;
        this.max = max;
        this.setPosition(this.getPosition());
    }
}
